diff --git a/sysdeps/powerpc/powerpc64/multiarch/bcopy.c b/sysdeps/powerpc/powerpc64/multiarch/bcopy.c
index 2840b17fdfd3..02eb1e6a9f66 100644
--- a/sysdeps/powerpc/powerpc64/multiarch/bcopy.c
+++ b/sysdeps/powerpc/powerpc64/multiarch/bcopy.c
@@ -28,10 +28,10 @@ extern __typeof (bcopy) __bcopy_power10 attribute_hidden;
 
 libc_ifunc (bcopy,
 #ifdef __LITTLE_ENDIAN__
-	     hwcap2 & (PPC_FEATURE2_ARCH_3_1 |
-		       PPC_FEATURE2_HAS_ISEL)
-	     && (hwcap & PPC_FEATURE_HAS_VSX)
-	     ? __bcopy_power10 :
+	    (hwcap2 & PPC_FEATURE2_ARCH_3_1
+	     && hwcap2 & PPC_FEATURE2_HAS_ISEL
+	     && hwcap & PPC_FEATURE_HAS_VSX)
+	    ? __bcopy_power10 :
 #endif
             (hwcap & PPC_FEATURE_HAS_VSX)
             ? __bcopy_power7
diff --git a/sysdeps/powerpc/powerpc64/multiarch/bzero.c b/sysdeps/powerpc/powerpc64/multiarch/bzero.c
index 50a5320c6650..660d7dc686ec 100644
--- a/sysdeps/powerpc/powerpc64/multiarch/bzero.c
+++ b/sysdeps/powerpc/powerpc64/multiarch/bzero.c
@@ -33,7 +33,8 @@ extern __typeof (bzero) __bzero_power10 attribute_hidden;
 
 libc_ifunc (__bzero,
 # ifdef __LITTLE_ENDIAN__
-	    (hwcap2 & (PPC_FEATURE2_ARCH_3_1 | PPC_FEATURE2_HAS_ISEL)
+	    (hwcap2 & PPC_FEATURE2_ARCH_3_1
+	     && hwcap2 & PPC_FEATURE2_HAS_ISEL
 	     && hwcap & PPC_FEATURE_HAS_VSX)
 	    ? __bzero_power10 :
 # endif
diff --git a/sysdeps/powerpc/powerpc64/multiarch/ifunc-impl-list.c b/sysdeps/powerpc/powerpc64/multiarch/ifunc-impl-list.c
index 49d9a33e65fe..b123c6a3d328 100644
--- a/sysdeps/powerpc/powerpc64/multiarch/ifunc-impl-list.c
+++ b/sysdeps/powerpc/powerpc64/multiarch/ifunc-impl-list.c
@@ -75,9 +75,9 @@ __libc_ifunc_impl_list (const char *name, struct libc_ifunc_impl *array,
   IFUNC_IMPL (i, name, memmove,
 #ifdef __LITTLE_ENDIAN__
 	      IFUNC_IMPL_ADD (array, i, memmove,
-			      hwcap2 & (PPC_FEATURE2_ARCH_3_1 |
-					PPC_FEATURE2_HAS_ISEL)
-			      && (hwcap & PPC_FEATURE_HAS_VSX),
+			      hwcap2 & PPC_FEATURE2_ARCH_3_1
+			      && hwcap2 & PPC_FEATURE2_HAS_ISEL
+			      && hwcap & PPC_FEATURE_HAS_VSX,
 			      __memmove_power10)
 #endif
 	      IFUNC_IMPL_ADD (array, i, memmove, hwcap & PPC_FEATURE_HAS_VSX,
@@ -88,8 +88,8 @@ __libc_ifunc_impl_list (const char *name, struct libc_ifunc_impl *array,
   IFUNC_IMPL (i, name, memset,
 #ifdef __LITTLE_ENDIAN__
 	      IFUNC_IMPL_ADD (array, i, memset,
-			      hwcap2 & (PPC_FEATURE2_ARCH_3_1 |
-					PPC_FEATURE2_HAS_ISEL)
+			      hwcap2 & PPC_FEATURE2_ARCH_3_1
+			      && hwcap2 & PPC_FEATURE2_HAS_ISEL
 			      && hwcap & PPC_FEATURE_HAS_VSX,
 			      __memset_power10)
 #endif
@@ -196,8 +196,8 @@ __libc_ifunc_impl_list (const char *name, struct libc_ifunc_impl *array,
   IFUNC_IMPL (i, name, bzero,
 #ifdef __LITTLE_ENDIAN__
 	      IFUNC_IMPL_ADD (array, i, bzero,
-			      hwcap2 & (PPC_FEATURE2_ARCH_3_1 |
-					PPC_FEATURE2_HAS_ISEL)
+			      hwcap2 & PPC_FEATURE2_ARCH_3_1
+			      && hwcap2 & PPC_FEATURE2_HAS_ISEL
 			      && hwcap & PPC_FEATURE_HAS_VSX,
 			      __bzero_power10)
 #endif
@@ -215,9 +215,9 @@ __libc_ifunc_impl_list (const char *name, struct libc_ifunc_impl *array,
   IFUNC_IMPL (i, name, bcopy,
 #ifdef __LITTLE_ENDIAN__
 	      IFUNC_IMPL_ADD (array, i, bcopy,
-			      hwcap2 & (PPC_FEATURE2_ARCH_3_1 |
-					PPC_FEATURE2_HAS_ISEL)
-			      && (hwcap & PPC_FEATURE_HAS_VSX),
+			      hwcap2 & PPC_FEATURE2_ARCH_3_1
+			      && hwcap2 & PPC_FEATURE2_HAS_ISEL
+			      && hwcap & PPC_FEATURE_HAS_VSX,
 			      __bcopy_power10)
 #endif
 	      IFUNC_IMPL_ADD (array, i, bcopy, hwcap & PPC_FEATURE_HAS_VSX,
diff --git a/sysdeps/powerpc/powerpc64/multiarch/memmove.c b/sysdeps/powerpc/powerpc64/multiarch/memmove.c
index 420c2f279af3..637b2cbf7f35 100644
--- a/sysdeps/powerpc/powerpc64/multiarch/memmove.c
+++ b/sysdeps/powerpc/powerpc64/multiarch/memmove.c
@@ -36,10 +36,10 @@ extern __typeof (__redirect_memmove) __memmove_power10 attribute_hidden;
 
 libc_ifunc (__libc_memmove,
 #ifdef __LITTLE_ENDIAN__
-	     hwcap2 & (PPC_FEATURE2_ARCH_3_1 |
-		       PPC_FEATURE2_HAS_ISEL)
-	     && (hwcap & PPC_FEATURE_HAS_VSX)
-	     ? __memmove_power10 :
+	    (hwcap2 & PPC_FEATURE2_ARCH_3_1
+	     && hwcap2 & PPC_FEATURE2_HAS_ISEL
+	     && hwcap & PPC_FEATURE_HAS_VSX)
+	    ? __memmove_power10 :
 #endif
 		     (hwcap & PPC_FEATURE_HAS_VSX)
 		     ? __memmove_power7
diff --git a/sysdeps/powerpc/powerpc64/multiarch/memset.c b/sysdeps/powerpc/powerpc64/multiarch/memset.c
index 6562646dffcf..5994bf02e622 100644
--- a/sysdeps/powerpc/powerpc64/multiarch/memset.c
+++ b/sysdeps/powerpc/powerpc64/multiarch/memset.c
@@ -41,7 +41,8 @@ extern __typeof (__redirect_memset) __memset_power10 attribute_hidden;
    ifunc symbol properly.  */
 libc_ifunc (__libc_memset,
 # ifdef __LITTLE_ENDIAN__
-	    (hwcap2 & (PPC_FEATURE2_ARCH_3_1 | PPC_FEATURE2_HAS_ISEL)
+	    (hwcap2 & PPC_FEATURE2_ARCH_3_1
+	     && hwcap2 & PPC_FEATURE2_HAS_ISEL
 	     && hwcap & PPC_FEATURE_HAS_VSX)
 	    ? __memset_power10 :
 # endif